<?php

/**
 * File: BadBehavior.Action.class.php
 * This is the Bad Behavior Action for the Geeklog Spam-X Plug-in!
 * 
 * Copyright (C) 2004-2005 by the following authors:
 * Authors       Tom Willett        tomw AT pigstye DOT net
 *               Dirk Haun          dirk AT haun-online DOT de
 * 
 * Licensed under GNU General Public License
 *
 * $Id: BadBehavior.Action.class.php,v 1.1 2006/12/31 12:29:52 dirk Exp $
 */

/**
 * Include Abstract Action Class
 */
require_once ($_CONF['path'] . 'plugins/spamx/' . 'BaseCommand.class.php');

/**
 * Action Class which adds spam posters to Bad Behavior's logfile
 * 
 * @author Dirk Haun    dirk AT haun-online DOT de
 */
class BadBehavior extends BaseCommand {
    /**
     * Constructor
     */
    function BadBehavior()
    {
        global $num;

        $num = 64;
    } 

    function execute($comment)
    {
        global $result, $_CONF, $_TABLES;

        // check if Bad Behavior plugin is installed and active
        $bb_active = DB_getItem ($_TABLES['plugins'], 'pi_enabled',
                                 "pi_name = 'bad_behavior'");
        if ($bb_active == 1) {
            // Since we're inside of a class when pulling in the Bad Behavior
            // files, we have to declare all these variables as global.
            // Will require adjustments when Michael introduces new global
            // variables ...
            global $_DB_table_prefix,
                   $wp_bb_approved, $wp_bb_db_failure, $wp_bb_remote_addr,
                   $wp_bb_request_method, $wp_bb_http_host, $wp_bb_request_uri,
                   $wp_bb_server_protocol, $wp_bb_http_referer,
                   $wp_bb_http_user_agent, $wp_bb_server_signature,
                   $wp_bb_headers, $wp_bb_http_headers,
                   $wp_bb_http_headers_mixed, $wp_bb_logging_duration,
                   $wp_bb_verbose_logging, $wp_bb_logging,
                   $wp_bb_request_entity;

            require_once ($_CONF['path_html']
                          . '/bad_behavior/bad-behavior-geeklog.php');

            wp_bb_log (403, 'Spam post detected by Spam-X');

            $result = 64;
        }

        return 0;
    }
}

?>
